"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _urlJoin = _interopRequireDefault(require("url-join"));

var _axios = _interopRequireDefault(require("axios"));

var BaseModel = function BaseModel() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      token = _ref.token,
      oauthToken = _ref.oauthToken,
      _ref$url = _ref.url,
      url = _ref$url === void 0 ? 'https://gitlab.com' : _ref$url,
      _ref$version = _ref.version,
      version = _ref$version === void 0 ? 'v4' : _ref$version;

  (0, _classCallCheck2.default)(this, BaseModel);
  this.url = (0, _urlJoin.default)(url, 'api', version);
  this.headers = {};
  this.requester = _axios.default;

  if (oauthToken) {
    this.headers.authorization = "Bearer ".concat(oauthToken);
  } else if (token) {
    this.headers['private-token'] = token;
  } else {
    throw new Error('`token` (private-token) or `oauth_token` is mandatory');
  }
};

var _default = BaseModel;
exports.default = _default;