"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _infrastructure = require("../infrastructure");

var EpicIssues =
/*#__PURE__*/
function (_BaseService) {
  (0, _inherits2.default)(EpicIssues, _BaseService);

  function EpicIssues() {
    (0, _classCallCheck2.default)(this, EpicIssues);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EpicIssues).apply(this, arguments));
  }

  (0, _createClass2.default)(EpicIssues, [{
    key: "all",
    value: function all(groupId, epicId) {
      var _map = [groupId, epicId].map(encodeURIComponent),
          _map2 = (0, _slicedToArray2.default)(_map, 2),
          gId = _map2[0],
          eId = _map2[1];

      return _infrastructure.RequestHelper.get(this, "groups/".concat(gId, "/epics/").concat(eId, "/issues"));
    }
  }, {
    key: "assign",
    value: function assign(groupId, epicId, issueId) {
      var _map3 = [groupId, epicId, issueId].map(encodeURIComponent),
          _map4 = (0, _slicedToArray2.default)(_map3, 3),
          gId = _map4[0],
          eId = _map4[1],
          iId = _map4[2];

      return _infrastructure.RequestHelper.put(this, "groups/".concat(gId, "/epics/").concat(eId, "/issues/").concat(iId));
    }
  }, {
    key: "edit",
    value: function edit(groupId, epicId, issueId, options) {
      var _map5 = [groupId, epicId, issueId].map(encodeURIComponent),
          _map6 = (0, _slicedToArray2.default)(_map5, 3),
          gId = _map6[0],
          eId = _map6[1],
          iId = _map6[2];

      return _infrastructure.RequestHelper.delete(this, "groups/".concat(gId, "/epics/").concat(eId, "/issues/").concat(iId), options);
    }
  }, {
    key: "remove",
    value: function remove(groupId, epicId, issueId) {
      var _map7 = [groupId, epicId, issueId].map(encodeURIComponent),
          _map8 = (0, _slicedToArray2.default)(_map7, 3),
          gId = _map8[0],
          eId = _map8[1],
          iId = _map8[2];

      return _infrastructure.RequestHelper.delete(this, "groups/".concat(gId, "/epics/").concat(eId, "/issues/").concat(iId));
    }
  }]);
  return EpicIssues;
}(_infrastructure.BaseService);

var _default = EpicIssues;
exports.default = _default;