"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _urlJoin = _interopRequireDefault(require("url-join"));

var _infrastructure = require("../infrastructure");

function url(projectId, resourceType, resourceId, noteId) {
  var _map = [projectId, resourceId].map(encodeURIComponent),
      _map2 = (0, _slicedToArray2.default)(_map, 2),
      pId = _map2[0],
      rId = _map2[1];

  var output = "".concat(pId, "/").concat(resourceType, "/").concat(rId, "/");

  if (noteId) {
    output += "notes/".concat(encodeURIComponent(noteId), "/");
  }

  output += 'award_emoji';
  return output;
}

var ResourceAwardsEmojis =
/*#__PURE__*/
function (_BaseService) {
  (0, _inherits2.default)(ResourceAwardsEmojis, _BaseService);

  function ResourceAwardsEmojis(resourceType) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ResourceAwardsEmojis);

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ResourceAwardsEmojis)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.url = (0, _urlJoin.default)(_this.url, 'projects');
    _this.resourceType = resourceType;
    return _this;
  }

  (0, _createClass2.default)(ResourceAwardsEmojis, [{
    key: "all",
    value: function all(projectId, resourceId, options, noteId) {
      return _infrastructure.RequestHelper.get(this, url(projectId, this.resourceType, resourceId, noteId), options);
    }
  }, {
    key: "award",
    value: function award(projectId, resourceId, name, noteId) {
      return _infrastructure.RequestHelper.post(this, url(projectId, this.resourceType, resourceId, noteId), {
        name: name
      });
    }
  }, {
    key: "remove",
    value: function remove(projectId, resourceId, awardId, noteId) {
      return _infrastructure.RequestHelper.delete(this, url(projectId, this.resourceType, resourceId, noteId));
    }
  }, {
    key: "show",
    value: function show(projectId, resourceId, awardId, noteId) {
      return _infrastructure.RequestHelper.get(this, url(projectId, this.resourceType, resourceId, noteId));
    }
  }]);
  return ResourceAwardsEmojis;
}(_infrastructure.BaseService);

var _default = ResourceAwardsEmojis;
exports.default = _default;