"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _urlJoin = _interopRequireDefault(require("url-join"));

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class BaseModel {
  constructor({
    token,
    oauthToken,
    url = 'https://gitlab.com',
    version = 'v4'
  } = {}) {
    this.url = (0, _urlJoin.default)(url, 'api', version);
    this.headers = {};
    this.requester = _axios.default;

    if (oauthToken) {
      this.headers.authorization = `Bearer ${oauthToken}`;
    } else if (token) {
      this.headers['private-token'] = token;
    } else {
      throw new Error('`token` (private-token) or `oauth_token` is mandatory');
    }
  }

}

var _default = BaseModel;
exports.default = _default;